DAT progamName byte "Roomba110830c", 0
CON
{{
----------------- Public Notes ------------------

  This program is used in a QuickStart board
  to control a Roomba.  Control information
  needs to be sent to the QS board from another
  Propeller board.
  The other Propeller board was programmed with
  Remote110827b.spin.
  Presently there isn't any autonomous activity
  programmed.
  This program allows remote driving of the Roomba.
  The cleaning motors can also be controlled from
  the remote.
  Both this program and the remote program were
  adapted from other projects.  I have not gone
  through the program to clean it up.
  There are a lot of unused variables and methods.
  
----------------- Private Notes ------------------
  (Board w)
  Modified from MecanumMotor110706c.spin

  110826a start defining pins used to
  interface a QuickStart board with
  a Roomba.
  27b is receiving data from Remote110827a.
  Both the speed and radius are way off.
  27f kind of works.  The radius is too
  large most of the time.  It seems to only
  go forward or turn in place.
  The Roomba had to be on in order for
  the Prop to communicate with it.
  28c I think I've fixed the speed.
  28d The radius is looking better in
  the terminal window.
  28e add button to play scale.
  28e works okay.  I think I need
  to decrease the max radius.  The
  robot does not make gentle turns.
  28f add cleaning motors and LEDs.
  28g add 7-segment display.  Turns are
  still not very smooth.  I think the
  speed needs to be reduced as the
  bot tries to turn.
  28h did not work well.  I slowed the
  speed using the x value.  Bad idea.
  29a didn't work well.
  29b not so good either.
  29c fixed ramping error.
  29e better but ramping too slow.
  29h major change.  Try to use forward
  speed and turning speed.
  30b increased minimun radius from 2
  to 260.  I think it helped.
  30c works better.  It is steerable.
  I think I'll post this version on
  the forum.
   
}}

CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000
 
  'Pins to Hong Kong Nordic nRF24L01+
  _SpiIrq = 0
  _SpiMiso = 1
  _SpiMosi = 2
  _SpiSck = 3 
  _SpiCsn = 4     
  _SpiCe = 5
  _RoombaTx = 16   
  _RoombaRx = 17
  _RoombaWake = 18
  _LedTxPin = 19
  '_LedPin = 23
  
  _DebugBaud = 57_600
  _RoombaBaud = 57_600
  _LedBaud = 9_600
  _Max16BitNeg = -32767 ' = $8000 + 1
  _Max16BitPos = 32767
  _RStart = 128
  _RBaud = 129
  _RControl = 130
  _RSafe = 131
  _RFull = 132
  _RPower = 133
  _RSpot = 134
  _RClean = 135
  _RMax = 136
  _RDrive = 137                 ' 4 data bytes [Velocity high][Velocity low]
                                ' [Radius high][Radius low] (Straight $8000)
  _RDriveStraight = $8000
  _RMotor = 138                 ' 1 data byte
  _RMotorMainBrush = %00000100
  _RMotorVacuum = %00000010
  _RMotorSideBrush = %00000001
  _RLed = 139                   ' 3 data bytes
  _RLedStatusRed = %00010000
  _RLedStatusGreen = %00100000
  _RLedStatusAmber = %00110000
  _RLedSpot = %00001000
  _RLedClean = %00000100
  _RLedMax = %00000010
  _RLedDirtDetect = %00000001
  _RSong = 140                  ' 2N + 2 data bytes (N = # of notes)
  _RPlay = 141                  ' 1 data byte
  _RSensors = 142               ' 1 data byte
  _RDock = 143                  ' I doubt this works
  
  
  _BadDataLimit = 16
  
  _CenterStickPs2 = 123
  _CenterPs2LeftXMin = 114
  _CenterPs2LeftXMax = 148 '142
  _CenterPs2LeftYMin = 119
  _CenterPs2LeftYMax = 135 '126
  _CenterPs2RightXMin = 101 '102
  _CenterPs2RightXMax = 141 '139
  _CenterPs2RightYMin = 100
  _CenterPs2RightYMax = 128 '126
  _CenterPs2LeftXSize = _CenterPs2LeftXMax - _CenterPs2LeftXMin
  _CenterPs2LeftYSize = _CenterPs2LeftYMax - _CenterPs2LeftYMin
  _CenterPs2RightXSize = _CenterPs2RightXMax - _CenterPs2RightXMin
  _CenterPs2RightYSize = _CenterPs2RightYMax - _CenterPs2RightYMin
  _Ps2JoyMax = $FF
  
  _CenterXNun = 129     ' This may need to be updated since I'm using a different controller.
  _CenterYNun = 130
  _FarRightNun = 26
  _FarLeftNun = 224
  _FarForwardNun = 223
  _FarBackNun = 29
  _ALowerDeadZone = 480
  _AUpperDeadZone = 500
  _ALowest = 330
  _AHighest = 660  
  
  _Stop = 1500
        
  _LineLength = 12
  _DefaultDelay = 6_000_000
  _SpeedCheckInterval = 8_000_000
  '_SpeedIntervalTooLong = _SpeedCheckInterval + ((_SpeedCheckInterval / 100) * 2)
  ' Only check speed if time interval is within 2%.  Or compute based on interval? 

  ' communication enumeration
  #0, _RoombaCom, _DebugCom, _LedCom  

  ' controller enumeration
  #0, _NoController, _PlayStation2, _WiiNunchuck

  ' mode enumeration
  #0, _AutonomousMode, _AllStopMode, _ManualDriveMode, _ProgramMode, _OverRideMode

  ' command mode enumeration
  #0, _OffCommand, _PassiveCommand, _SafeCommand, _FullCommand
    
  ' sub mode enumeration
  #0, _Undefined, _ModifyProportionalMode, _ModifyIntegralMode, _ModifyDerivativeMode, {
    } _ModifyTextDelayMode, _EnterModifyMessageMode, _ModifyMessageModeL1, _ModifyMessageModeL2, {
    } _ModifyMessageModeR1, _ModifyMessageModeR2
  
  ' cog enumeration
  #0, _ComCog, _NordicCog, _MathCog, _LedCog

  ' motor states
  #0, _OffMotor, OnMotor

  ' motor enumeration
  #0, _MainBrushMotor, _VacuumMotor, _SideBrushMotor, _AllMotor

  ' LED enumeration
  #0, _Status0Led, _Status1Led, _SpotLed, _CleanLed, _MaxLed, _DirtLed, _PowerLed

  ' display mode
  #0, _SpeedDisplay, _RadiusDisplay

  WirelessCom = 5  ' use an out of range number until setCount is used 5 '

  _DefaultRampWheels = 50


  _SpeedScalarNumerator = _MaxSpeed
  _SpeedScalarDenominator = 110 '123 '100 '_CenterPs2RightXMin
  '_MinAllowedSpeed = 2000 ' speed shouldn't be between 0 and 2000 (I think this might
                          ' help the motor controller chips and the motors last longer
                          ' and produce less heat.)
  '_MinSpeedAdjustPoint = _MinAllowedSpeed / 2
  ' If the speed is between _MinSpeedAdjustPoint and _MinAllowedSpeed the speed should
  ' be increased to _MinAllowedSpeed.  If speed is between _MinSpeedAdjustPoint and zero,
  ' speed should be set to zero.
  
VAR

  long cog[7]
  long targetAngle, targetSpeed, fTargetAngle, fTargetSpeed
  long fZero, f90r
  long fThousand, f120r, f180r, f45r, f255
  long x, y, fX, fY, fFraction
  long targetRotationSpeed, adjustSpeed
  long delay 
  long rxFlag[2], oldRxFlag[2]
  long rotation, fMaxAllowedSpeed, fSpeedScalar
  long targetWheelSpeed00[4], targetWheelSpeed[4]
  long fTargetWheelSpeed00[4], fTargetWheelSpeed[4]
  long PsData1, PsData2
  long globalTime, globalTimeOld
  long oldPosition[4]
  long previousSpeed, previousRadius
  
  word axRaw, ayRaw, azRaw, oldAx, oldAy, oldAz
  byte jx, jy, bc, bz, oldJx, oldJy, oldBc, oldBz
  
  byte maxWheel, minWheel, positivePin[4], negativePin[4]
  byte setCount[2]
  byte linesToExpectCom[2], endOfTransExceptionFlag, tempBuffer[Header#_LargeBufferSize]
  byte endChar, encoderPinA[4], encoderPinB[4]
  byte proportionalGain, integralGain, derivativeGain
  byte leftX, leftY, rightX, rightY
  byte controllerButtons[16], controllerButtonsOld[16]
  byte type, currentController, mode, subMode
  byte globalPayloadRx[Header#_LargestPayloadSize + 1]
  byte payloadSize, badDataFlag
  byte roombaMode, motorState[4], ledState[7], displayMode 
  
OBJ

  Com : "pcFullDuplexSerial4FC512Flags110301a"                 ' uses one cog
  Header : "RoombaHeader110828a" 'Header110530a"
  FMath : "F32" '"Float32Full"                                 ' uses one cog 
  FString : "FloatString"

  Nordic : "NordicBeta110827a"    
  'Header : "PanicHeader110808a"
  'Eeprom : "Eeprom110713a"
  
PUB Main | localIndex

  mode := _ManualDriveMode

  delay := _DefaultDelay
  previousSpeed := 0
  previousRadius := _RDriveStraight
  
  payloadSize := byte[@configNew + Nordic#_PayloadOffset] '_DefaultPayloadSize
  
  endChar := 13
  linesToExpectCom[_DebugCom] := 1
  linesToExpectCom[_RoombaCom] := 1

  globalTime := globalTimeOld := cnt
  
  cog[_MathCog] := FMath.Start - 1
  f90r := 90
  fThousand := 1000
  f45r := 45
  f120r := 120
  f180r := 180
  f255 := 255
  f90r := FMath.fFloat(f90r)
  fThousand := FMath.fFloat(fThousand)
  f45r := FMath.fFloat(f45r)
  f120r := FMath.fFloat(f120r)
  f180r := FMath.fFloat(f180r)
  f255 :=  FMath.fFloat(f255)
  fMaxAllowedSpeed :=  FMath.fFloat(_MaxSpeed)
  f45r := FMath.radians(f45r)
  f120r := FMath.radians(f120r)
  f180r := FMath.radians(f180r)

  fSpeedScalar := FMath.fFloat(_SpeedScalarNumerator)    
  fZero := FMath.fFloat(_SpeedScalarDenominator) ' use fZero as a temp variable
  fSpeedScalar := FMath.fDiv(fSpeedScalar, fZero)    
   
  fZero := 0
  fZero := FMath.fFloat(fZero)
  
  'Set IRQ pin state 
  dira[_SpiIrq]~

  
  waitcnt(clkfreq / 2 + cnt)
  Com.AddPort(_RoombaCom, _RoombaRx, _RoombaTx, -1, -1, 0, 0, _RoombaBaud)
  Com.AddPort(_DebugCom, Header#_DebugRxPin, Header#_DebugTxPin, -1, -1, 0, 0, _DebugBaud)
  Com.AddPort(_LedCom, -1, _LedTxPin, -1, -1, 0, 0, _LedBaud)
  Com.SetFlags(13, 13, 13, 13, @rxFlag)
  cog[_ComCog] := Com.Start
  waitcnt(clkfreq / 100 + cnt) 
  
  cog[_NordicCog] := Nordic.Start(_SpiSck, _SpiMiso, _SpiMosi, _SpiCsn, _SpiCe, @configNew)
  'nordicCog := Nordic.Start(spiSck, spiMiso, spiMosi, spiCsn, spiCe, @config)
  waitcnt(clkfreq + cnt)
  {
  localIndex := -1
  repeat while localIndex == -1
    Tbug(string(13, "Press and key to start."))
    localIndex := Com.rxcheck(_DebugCom)
    waitcnt(clkfreq / 4 + cnt)
  }
  Tbug(string(13, "Program Name = "))
  Tbug(@progamName)
  Tbug(string(13, "fSpeedScalar = ")) 
  Tbug(FString.FloatToString(fSpeedScalar))
  
  {
  repeat localIndex from 0 to _Motor3Cog
    Tbug(string(13, "cog[")) 
    TbugDec(localIndex)
    Tbug(string("] = "))
    TbugDec(cog[localIndex])
  }  
  Com.str(_DebugCom, string(13, "Start with everything off."))
  
  fTargetAngle := f90r
  fTargetSpeed := fZero
  rotation := 0
  targetSpeed := 0
  roombaMode := _OffCommand
  
  SetMode(_SafeCommand)
  SendCommand(_RSong, 32, @song0)
  waitcnt(clkfreq / 10 + cnt)
  roombaData[0] := 0
  SendCommand(_RPlay, 1, @roombaData)
  waitcnt(clkfreq * 4 + cnt)
  
  MainLoop
  
PUB MainLoop | localIndex, localSize, loopCounter, badDataCount, localCharacter

  loopCounter := 0
  badDataCount := 0
  repeat     
    loopCounter++
    'waitcnt(clkfreq / 50 + cnt)

    if rxFlag[_DebugCom] <> oldRxFlag[_DebugCom]
      localSize := FlushBuffer(_DebugCom)
      if localSize > 0
        'if tempBuffer[0] == "l"
          'PassThroughDebug
        if tempBuffer[0] == "o"
          OverRideWithDebug  
    if ina[_SpiIrq]  == 0 'Wait for incoming data  
     
      'Tbug(string(13, "Nordic received = "))
      Nordic.ReadPayload(@globalPayloadRx)
      'Tbug(string(13, "after ReadPayload = "))
      'SafeBug(@globalPayloadRx, payloadSize)

      if globalPayloadRx[0] == 1 and globalPayloadRx[1] == 2
        if globalPayloadRx[2] == "w" and globalPayloadRx[3] == "u"
          if globalPayloadRx[6] == Header#_ContollerStream
            currentController := globalPayloadRx[7]
            ComputeDirection(currentController)

            'Tbug(string(13, "targetAngle = "))
            Tbug(string(", tA= "))
            TbugDec(targetAngle)
            Tbug(string(", tS= "))
            TbugDec(targetSpeed)
            'Tbug(string(", radius = "))
            'TbugDec(rotation)
           
            if badDataFlag == 0
              badDataCount := 0
              SendVelocity
            else
              if ++badDataCount => _BadDataLimit
                                  
      'TbugTx(13)
    {  
    localCharacter := Com.rxcheck(_RoombaCom)
    if localCharacter <> -1
      Tbug(string(13, "received from Roomba = "))            
      TbugTx(localCharacter)
      Tbug(string(13, "Presently data from the Roomba"))
      Tbug(string(13, "isn't used."))
      Tbug(string(13, "It will be used in the future."))
      '**** Add Roomba data transfer
     }
    {         
    Tbug(string("     loopCounter = "))
    TbugDec(loopCounter)
    TbugTx(13)
    }

PUB SendCommand(localCommand, localSize, localPtr)

  Tbug(string(13, "SendCommand = "))
  TbugTx(localCommand)
  Com.tx(_RoombaCom, localCommand)
  repeat localSize
    TbugTx(byte[localPtr])
    Com.tx(_RoombaCom, byte[localPtr++])
    
PUB OverRideWithDebug | localMode, localCharacter, localNumber, {
                      } localIndex, negativeFlag, localSize

  mode := _OverRideMode
  localMode := 0                ' waiting for engine number
  
  fTargetSpeed := fZero
  x := 0
  y := 0
  rotation := 0
  targetSpeed := 0
  SendVelocity  ' Turn off all motors
  Tbug(string(13, "Entering Over Ride Mode"))
  Tbug(string(13, "Enter ", 34, "x", 34, " to exit over ride mode."))
  Tbug(string(13, "Enter ", 34, "s", 34, " to change speed."))
  Tbug(string(13, "Enter ", 34, "r", 34, " to change radius."))
      
  repeat while mode == _OverRideMode
    waitcnt(clkfreq / 10 + cnt) 
    Tbug(string(13, "speed = "))    
    TbugDec(targetSpeed)
    TbugTx(44)                  ' add a comma and space between numbers
    TbugTx(32)
    Tbug(string(" radius = "))
    TbugDec(rotation)
    TbugTx(44)                  ' add a comma and space between numbers
    TbugTx(32)
     
    if rxFlag[_DebugCom] <> oldRxFlag[_DebugCom]
      localSize := FlushBuffer(_DebugCom)
      if localSize > 0
        if tempBuffer[0] == "x"
          x := 0
          y := 0
          rotation := 0
          targetSpeed := 0
          fTargetSpeed := fZero
          SendVelocity
          mode := _AllStopMode
        elseif localMode == 0
          if tempBuffer[0] == "s"
            localMode := 1
            Tbug(string(13, "Enter targetSpeed"))
          elseif tempBuffer[0] == "r"
            localMode := 2
            Tbug(string(13, "Enter radius"))  
        elseif localMode > 0
          localNumber := 0
          localIndex := 0
          negativeFlag := 0
          localCharacter := 0
          repeat while localCharacter <> 13        
            localCharacter := tempBuffer[localIndex++]
            if localCharacter => "0" and localCharacter =< "9"
              localNumber := (localNumber * 10) + (localCharacter - "0")
            elseif localCharacter == "-"
              negativeFlag := 1
          if negativeFlag == 1
            localNumber *= -1
          if localMode == 1      
            Tbug(string(13, "New speed is "))
            TbugDec(localNumber)            
            targetSpeed := localNumber
          elseif localMode == 2      
            Tbug(string(13, "New radius is "))
            TbugDec(localNumber)
            rotation := localNumber
          localMode := 0
          Tbug(string(13, "Enter ", 34, "x", 34, " to exit over ride mode."))
          Tbug(string(13, "Enter ", 34, "s", 34, " to change speed."))
          Tbug(string(13, "Enter ", 34, "r", 34, " to change radius."))  
          waitcnt(clkfreq * 2 + cnt)
          
{PUB PassThroughDebug | localIndex

  case localIndex[0]
    "l":
      SendLedText(@localIndex + 1)
      
PUB PassThroughRx| localIndex

  setCount++
  if setCount == 13 or setCount == 0
    setCount++
  bytefill(@nordicTxBuffer + 5, 0, payloadSize - 6)
  nordicTxBuffer[2] := tempBuffer[2]
  nordicTxBuffer[3] := tempBuffer[3]
  nordicTxBuffer[4] := setCount
  localIndex := 4
  repeat while tempBuffer[localIndex] <> 13 and localIndex < (Header#_MecanumPayloadSize - 2)
    nordicTxBuffer[localIndex + 1] := tempBuffer[localIndex++]
  nordicTxBuffer[localIndex + 1] := 13  
  Nordic.TransmitString(@nordicTxBuffer)
  Tbug(string(13, "SafeBug(@nordicTxBuffer, "))
  TbugDec(localIndex + 1)
  Tbug(string(") = "))
  SafeBug(@nordicTxBuffer, localIndex + 1)
  waitcnt(clkfreq / 2 + cnt)
}          
PUB ComputeDirection(localController)

          
  badDataFlag := 0
  if localController == Header#_NoController
    badDataFlag := 1
    return
  elseif localController == Header#_PlayStation2
    PsData1 := hexToLong(@globalPayloadRx[8])
    PsData2 := hexToLong(@globalPayloadRx[16])
    if (PsData1 == $FFFFFFFF and PsData2 == $FFFFFFFF) {
   }or (PsData1 == 0 and PsData2 == 0)
      badDataFlag := 1
      return
    GetPs2XYs
    'Tbug(string(13, "rX= ")) ' far left = 0
    'TbugDec(rightX)
    'Tbug(string(", rY= ")) ' forward = 0
    'TbugDec(rightY)
    if rightX < _CenterPs2RightXMin
      x := rightX - _CenterPs2RightXMin
    elseif rightX > _CenterPs2RightXMax
      x := rightX - _CenterPs2RightXMax
    else
      x := 0
    if rightY < _CenterPs2RightYMin
      y := _CenterPs2RightYMin - rightY
    elseif rightY > _CenterPs2RightYMax
      y := _CenterPs2RightYMax - rightY
    else
      y := 0  
    if leftX < _CenterPs2LeftXMin
      rotation := leftX - _CenterPs2LeftXMin
    elseif leftX > _CenterPs2LeftXMax
      rotation := leftX - _CenterPs2LeftXMax
    else
      rotation := 0
    if controllerButtons[Header#_LeftJoystickPs2] == 1 and controllerButtonsOld[Header#_LeftJoystickPs2] == 0
      if displayMode == _SpeedDisplay
        displayMode := _RadiusDisplay
      else
        displayMode := _SpeedDisplay  
    {if controllerButtons[Header#_AllMotorsStopPs2] == 1
      Tbug(string(13, "_AllStopMode"))
      mode := _AllStopMode
      subMode := _Undefined
      x := 0
      y := 0
      rotation := 0
      targetSpeed := 0
      SendVelocity
    {elseif controllerButtons[Header#_StartPs2] == 1
      if mode == _ProgramMode
        'SendLedText(string("Exiting Program Mode"))
        SendLedText(string("Exit P Mode"))
      mode := _ManualDriveMode
      subMode := _Undefined 
    elseif mode == _ProgramMode
      ProgramMode       
      x := 0
      y := 0
      rotation := 0  }
    elseif controllerButtons[Header#_EnterProgramModePs2] == 1
      'SendLedText(string("Entering Program Mode"))
      SendLedText(string("P Mode"))
      mode := _ProgramMode
      subMode := _Undefined      
      x := 0
      y := 0
      rotation := 0 }
      
    elseif controllerButtons[Header#_R1Ps2] == 1 and controllerButtonsOld[Header#_R1Ps2] == 0
      roombaData[0] := 0
      SendCommand(_RPlay, 1, @roombaData)
      'waitcnt(clkfreq * 4 + cnt)
    elseif controllerButtons[Header#_L1Ps2] == 1 and controllerButtonsOld[Header#_L1Ps2] == 0
      roombaData[0] := 0
      SendCommand(_RPlay, 1, @roombaData)
    if controllerButtons[Header#_SquarePs2] == 1 and controllerButtonsOld[Header#_SquarePs2] == 0
      ToggleLed(_MaxLed)
    if controllerButtons[Header#_CrossPs2] == 1 and controllerButtonsOld[Header#_CrossPs2] == 0
      ToggleLed(_DirtLed)
    if controllerButtons[Header#_CirclePs2] == 1 and controllerButtonsOld[Header#_CirclePs2] == 0
      ToggleLed(_SpotLed)
    if controllerButtons[Header#_TrianglePs2] == 1 and controllerButtonsOld[Header#_TrianglePs2] == 0
      ToggleLed(_CleanLed)
    if controllerButtons[Header#_L2Ps2] == 1 and controllerButtonsOld[Header#_L2Ps2] == 0
      ToggleLed(_Status0Led)
    if controllerButtons[Header#_R2Ps2] == 1 and controllerButtonsOld[Header#_R2Ps2] == 0
      ToggleLed(_Status1Led)
    if controllerButtons[Header#_RightJoystickPs2] == 1 and controllerButtonsOld[Header#_RightJoystickPs2] == 0
      ToggleLed(_PowerLed)
    if controllerButtons[Header#_DownArrowPs2] == 1 and controllerButtonsOld[Header#_DownArrowPs2] == 0
      ToggleMotor(_AllMotor)
    if controllerButtons[Header#_LeftArrowPs2] == 1 and controllerButtonsOld[Header#_LeftArrowPs2] == 0
      ToggleMotor(_MainBrushMotor)
    if controllerButtons[Header#_UpArrowPs2] == 1 and controllerButtonsOld[Header#_UpArrowPs2] == 0
      ToggleMotor(_VacuumMotor)
    if controllerButtons[Header#_RightArrowPs2] == 1 and controllerButtonsOld[Header#_RightArrowPs2] == 0
      ToggleMotor(_SideBrushMotor)
    
    {elseif controllerButtons[Header#_R2Ps2] == 1 and controllerButtonsOld[Header#_R2Ps2] == 0
      SendLedMessageCode(Header#_LedMessageR2)
    elseif controllerButtons[Header#_L2Ps2] == 1 and controllerButtonsOld[Header#_L2Ps2] == 0
      SendLedMessageCode(Header#_LedMessageL2)
    elseif controllerButtons[Header#_LeftJoystickPs2] == 1 and controllerButtonsOld[Header#_LeftJoystickPs2] == 0
      SendLedMessageCode(Header#_LedMessagePattern)
   }   
   {' mode enumeration
  #0, _AutonomousMode, _AllStopMode, _ManualDriveMode, _ProgramMode
    
  ' sub mode enumeration
  #0, _Undefined, _ModifyProportionalMode, _ModifyIntegralMode, _ModifyDerivativeMode}   
  elseif localController == Header#_WiiNunchuck
    jx := FromAsciiHex(2, @globalPayloadRx[8])
    jy := FromAsciiHex(2, @globalPayloadRx[10])
    bc := FromAsciiHex(2, @globalPayloadRx[12])
    bz := FromAsciiHex(2, @globalPayloadRx[14])
    axRaw := FromAsciiHex(4, @globalPayloadRx[16])
    ayRaw := FromAsciiHex(4, @globalPayloadRx[20])
    azRaw := FromAsciiHex(4, @globalPayloadRx[24])
    if axRaw == $FFFF and ayRaw == $FFFF
      badDataFlag := 1
      return
    x := jx - _CenterXNun
    y := jy - _CenterYNun
    if axRaw < _ALowerDeadZone
      rotation := axRaw - _ALowerDeadZone
    elseif axRaw > _AUpperDeadZone
      rotation := axRaw - _AUpperDeadZone 
    else
      rotation := 0
  'x *= 2
  'y *= 2   _Ps2JoyMax  _MaxAllowedSpeed _SpeedScalar
  Tbug(string(13, "x= ")) ' left is negative
  TbugDec(x)
  Tbug(string(", y= ")) ' forward is negative
  TbugDec(y)
  fX := FMath.fFloat(x)
  fY := FMath.fFloat(y)
  fTargetSpeed := FMath.FSqr(FMath.fAdd(FMath.fMul(fX, fX), FMath.fMul(fY, fY)))
  fTargetSpeed := FMath.FMul(fTargetSpeed, fSpeedScalar)
  
  if x == 0
    if y > 0
      fTargetAngle := FMath.fDiv(f180r, 2.0)
    else
      fTargetAngle := FMath.fDiv(f180r, -2.0)
  else
    fFraction := FMath.fdiv(fY, fX)
    fTargetAngle := FMath.ATan(fFraction)
  if x < 0 
    fTargetAngle := FMath.fAdd(fTargetAngle, f180r) 
  'targetAngle := FMath.FRound(fTargetAngle)
  targetAngle := FMath.FRound(FMath.degrees(fTargetAngle))
  targetSpeed := FMath.FRound(fTargetSpeed)
 
PUB GetPs2XYs | localIndex, tempButton, dataToChop, lastBit, nextButton

  rightX := PsData2 & $000000FF  
  rightY := PsData2 >> 8 & $000000FF 
  leftX := PsData2 >> 16 & $000000FF 
  leftY := PsData2 >> 24 & $000000FF 
  dataToChop:= PsData1
  'Tbug(string(13, "dataToChop = %"))
  'TbugBin(dataToChop, 32)
  nextButton := 32 
  bytemove(@controllerButtonsOld, @controllerButtons, 16)
  dataToChop >>= 16
  localIndex := 15
  'Tbug(string(", %"))
  'TbugBin(dataToChop, 32)
  repeat 16
    lastBit := dataToChop & 1
    if lastBit == 1
      controllerButtons[localIndex] := 0
    else
      controllerButtons[localIndex] := 1
    dataToChop >>= 1
    localIndex--
     
  {bytefill(@controllerButtons, 0, 16)
  repeat 
    tempButton := >|dataToChop
    Tbug(string(13, "tempButton = "))
    TbugDec(tempButton)
    repeat while nextButton > tempButton
      controllerButtons[32 - nextButton] := 1
    if tempButton > 16
      controllerButtons[32 - tempButton] := 0 
      deleteMask := 1
      deleteMask <<= (tempButton - 1)
      dataToChop -= deleteMask
  while nextButton > 15' tempButton > 17 }
CON

  _MaxSpeed = 500 '1023
  _MinSpeed = -500 '-1023
  _MaxRadius = 1000 '2000 ' 
  _MinRadius = -1000 '-2000 ' 
  _LowRadius = _WheelWidth / 2
  _RangeRadius = _MaxRadius - _LowRadius
  _AdjustRadius = _MaxRadius - _RangeRadius
  '_SpeedCorrection = 2
  _SpeedRamp = 100 '40 ' 20
  _RadiusRamp = 200 '80 ' 40
  _WheelWidth = 260
  _RadiusScalarDenominator = 100
  
PUB SendVelocity | tempLong, localRadius, localSlope, localCorrection, innerSpeed, rampFlag, weight
'  _MaxSpeed = 500 '1023
'  _MinSpeed = -500 '-1023
'  _MaxRadius = 2000
'  _MinRadius
'  fSpeedScalar := FMath.fFloat(_SpeedScalarNumerator)    
'  fZero := FMath.fFloat(_SpeedScalarDenominator) ' use fZero as a temp variable
'  fSpeedScalar := FMath.fDiv(fSpeedScalar, fZero)    
  
  if y < 0
    targetSpeed *= -1
    'localCorrection := _SpeedCorrection * ||x
  'else
    'localCorrection := _SpeedCorrection * ||x * -1   }
  if x == 0
    localRadius := _RDriveStraight
  elseif y == 0
    if x < 0             ' ccw
      'targetSpeed := rotation
      localRadius := 1
    else
      'targetSpeed := rotation * -1
      localRadius := -1  
  else
    'localSlope := (_MaxRadius * 100) /  _SpeedScalarDenominator
    localSlope := (_RangeRadius * 100) /  _RadiusScalarDenominator
    
    Tbug(string(", m= "))
    TbugDec(localSlope)
    'weight := _SpeedScalarDenominator / x
    'weight #>= 
    if x < 0
      'localSlope := (_SpeedScalarDenominator * 1000) / _MaxRadius
      'localRadius := ((localSlope * x) / 1000) + _MaxRadius
      'localSlope := (_SpeedScalarDenominator * 1000) / _MinRadius
      'localRadius := ((localSlope * x) / 1000) + _MaxRadius
      localRadius := _MaxRadius + ((localSlope * x) / 100)
      localRadius #>= _LowRadius '2 '_Max16BitNeg
      innerSpeed := (localRadius * targetSpeed) / (localRadius + _WheelWidth)   
    else
      'localSlope := (_SpeedScalarDenominator * 1000) / _MinRadius
      'localRadius := ((localSlope * x) / 1000) + _MinRadius
      'localSlope := (_SpeedScalarDenominator * 1000) / _MaxRadius
      localRadius := _MinRadius + ((localSlope * x) / 100)
      localRadius <#= _LowRadius * -1 '-2 '_Max16BitPos
      innerSpeed := (localRadius * targetSpeed) / (localRadius - _WheelWidth)
    targetSpeed := (targetSpeed + innerSpeed) / 2
  targetSpeed <#= _MaxSpeed
  targetSpeed #>= _MinSpeed
  'targetSpeed += localCorrection
  
  if targetSpeed <> previousSpeed or localRadius <> previousRadius
    {if previousSpeed - targetSpeed > _SpeedRamp ' slowing down
      targetSpeed := previousSpeed - _SpeedRamp
    elseif targetSpeed - previousSpeed > _SpeedRamp ' speeding up
      targetSpeed := previousSpeed + _SpeedRamp
    rampFlag := 1   
    if localRadius == _RDriveStraight and previousRadius <> _RDriveStraight
      if _MaxRadius - ||previousRadius < _RadiusRamp
        localRadius := _RDriveStraight
        rampFlag := 0
      else
        if previousRadius > 0
          localRadius := _MaxRadius
        else  
          localRadius := _MinRadius      
    elseif localRadius <> _RDriveStraight and previousRadius == _RDriveStraight
      if localRadius > 0
        previousRadius := _MaxRadius
      else  
        previousRadius := _MinRadius   
    if rampFlag == 1
      if previousRadius - localRadius > _RadiusRamp 
        localRadius := previousRadius - _RadiusRamp
      elseif localRadius - previousRadius > _RadiusRamp 
        localRadius := previousRadius + _RadiusRamp  }
    'Tbug(string(13, "targetSpeed = "))
    previousSpeed := targetSpeed
    previousRadius := localRadius
    Com.tx(_LedCom, "v")
    if displayMode == _SpeedDisplay      
      Com.dec(_LedCom, targetSpeed)
    else
      Com.dec(_LedCom, localRadius)
    tempLong := localRadius
    roombaData[3] := tempLong
    tempLong >>= 8
    roombaData[2] := tempLong
    tempLong := targetSpeed
    roombaData[1] := tempLong
    tempLong >>= 8
    roombaData[0] := tempLong
    SendCommand(_RDrive, 4, @roombaData) 
    
  Tbug(string(", tS= "))
  TbugDec(targetSpeed)
  Tbug(string(", lR= "))
  if localRadius == _RDriveStraight
    TbugHex(localRadius, 4)
  else  
    TbugDec(localRadius) 
                     
PUB SetMode(localCommand)
  ' command mode enumeration
  '#0, _OffCommand, _PassiveCommand, _SafeCommand, _FullCommand
  ' roombaMode
  Tbug(string(13, "SetMode Method"))
  Tbug(string(13, "localCommand = "))
  TbugDec(localCommand)
  Tbug(string(13, "roombaMode was = "))
  TbugDec(roombaMode)
   
  case localCommand
    _OffCommand:
      if roombaMode == _OffCommand
        Tbug(string(13, "roombaMode already set to _OffCommand"))
      else
        SendCommand(_RPower, 0, @roombaData)
      roombaMode := _OffCommand
    _PassiveCommand:
      if roombaMode == _PassiveCommand
        Tbug(string(13, "roombaMode already set to _PassiveCommand")) 
      else
        if roombaMode > _PassiveCommand
          SendCommand(_RPower, 0, @roombaData)
          waitcnt(clkfreq / 10 + cnt)
        OffToPassive      
      roombaMode := _PassiveCommand   
    _SafeCommand:
      if roombaMode == _SafeCommand
        Tbug(string(13, "roombaMode already set to _SafeCommand")) 
      elseif roombaMode == _FullCommand
        SendCommand(_RSafe, 0, @roombaData)      
      else ' off or passive
        if roombaMode == _OffCommand  
          OffToPassive
        SendCommand(_RControl, 0, @roombaData)
      roombaMode := _SafeCommand     
    _FullCommand:
      if roombaMode == _FullCommand
        Tbug(string(13, "roombaMode already set to _FullCommand"))
      else
        if roombaMode == _OffCommand  
          OffToPassive
        if roombaMode < _SafeCommand
          SendCommand(_RControl, 0, @roombaData)
          waitcnt(clkfreq / 10 + cnt)
        SendCommand(_RFull, 0, @roombaData)
      roombaMode := _FullCommand          
  Tbug(string(", roombaMode now = "))
  TbugDec(roombaMode)
  waitcnt(clkfreq / 10 + cnt)
  
PRI OffToPassive

  outa[_RoombaWake] := 0
  dira[_RoombaWake] := 1
  waitcnt(clkfreq / 2 + cnt)
  SendCommand(_RStart, 0, @roombaData)
  waitcnt(clkfreq / 10 + cnt)
          
PUB ToggleMotor(localMotor) | localIndex
'  _RMotor = 138                 ' 1 data byte
'  _RMotorMainBrush = %00000100
'  _RMotorVacuum = %00000010
'  _RMotorSideBrush = %00000001
  
  roombaData[0] := 0
  if motorState[localMotor] == 1
    motorState[localMotor] := 0
  else
    motorState[localMotor] := 1
  if localMotor == _AllMotor
    repeat localIndex from _MainBrushMotor to _SideBrushMotor
      motorState[localIndex] := motorState[_AllMotor]
  repeat localIndex from _MainBrushMotor to _SideBrushMotor
    roombaData[0] <<= 1
    roombaData[0] += motorState[localIndex]
  SendCommand(_RMotor, 1, @roombaData)
     
PUB ToggleLed(localLed) | localIndex
  
  roombaData[0] := 0
  if localLed == _PowerLed
    if ledState[localLed] == $FF
      ledState[localLed] := 0
    else
      ledState[localLed] := $FF
  else     
    if ledState[localLed] == 1
      ledState[localLed] := 0
    else
      ledState[localLed] := 1
  repeat localIndex from _Status0Led to _DirtLed
    roombaData[0] <<= 1
    roombaData[0] += ledState[localIndex]
  roombaData[1] := ledState[_PowerLed]
  roombaData[2] := $FF
  SendCommand(_RLed, 3, @roombaData)
    
PUB hexToLong(localPtr) | localCharacter  

  repeat 8
    localCharacter := byte[localPtr++]
    if localCharacter => "0" and localCharacter =< "9"
      localCharacter -= "0"
    elseif localCharacter => "A" and localCharacter =< "F"
      localCharacter -= "A"
      localCharacter += $0A
    else
      localCharacter := 0
    result <<= 4
    result += localCharacter
     
PUB FromAsciiHex(digits, localPtr) | localCharacter  

  repeat digits
    localCharacter := byte[localPtr++]
    if localCharacter => "0" and localCharacter =< "9"
      localCharacter -= "0"
    elseif localCharacter => "A" and localCharacter =< "F"
      localCharacter -= "A"
      localCharacter += $0A
    else
      localCharacter := 0
    result <<= 4
    result += localCharacter
     
PUB Hex(value, digits, localPtr)
'' Print a hexadecimal number
  value <<= (8 - digits) << 2
  repeat digits
    byte[localPtr++] := lookupz((value <-= 4) & $F : "0".."9", "A".."F")
      
PRI FlushBuffer(localBufferIndex) | localCharacter, localIndex, linesOut', previousWirelessCharacter

   if rxFlag[localBufferIndex] == oldRxFlag[localBufferIndex]                              
    Tbug(string(13, "No buffer data, rxFlag["))
    TbugDec(localBufferIndex)
    Tbug(string("] = "))
    TbugDec(rxFlag[localBufferIndex])
    return 0

  'previousWirelessCharacter := 0                        ' I don't think this is used anymore.
  localIndex := 0
  linesOut := linesToExpectCom[localBufferIndex]
  repeat while linesOut > 0
    if localIndex => Header#_LargeBufferSize
      Tbug(string(13, "tempBuffer full!", 13))
      Tbug(string("This shouldn't happen.", 13)) 
      quit
    localCharacter := Com.rxcheck(localBufferIndex)
    if localCharacter == -1
      Tbug(string(13, "rx buffer empty!!!", 13))
      Tbug(string("Data is missing!!!", 13))
      Tbug(string("linesOut = "))
      TbugDec(linesOut)
      TbugTx(13)
      localCharacter := endChar
    tempBuffer[localIndex] := localCharacter
    
    {if localBufferIndex == WirelessCom
      if localIndex == 0
        'previousWirelessCharacter := localCharacter
      'elseif localIndex == 1 and previousWirelessCharacter == Header#_WirelessAck
       
        'if localCharacter == setCount[xbeeSettings[Header#_TargetSerial]]
        'acknowledgeFlag[xbeeSettings[Header#_TargetSerial]]++
      elseif localIndex == 4
        ' The fifth byte of the message is the setCount value.
        Com.tx(_XBeeCom, Header#_WirelessAck)
        ' check for missed transmission
        'setCount[xbeeSettings[Header#_AttachedSerial
        Com.tx(_XBeeCom, localCharacter)
        Com.tx(_XBeeCom, endChar) }
    if localCharacter == endChar 
      linesOut--
    localIndex++
  tempBuffer[localIndex] := 0   ' is this needed?
  'Tbug(@tempBuffer)
  oldRxFlag[localBufferIndex]++
  'SafeBug(@tempBuffer, localIndex)
 
  result := localIndex 

PUB SafeBug(localPtr, localSize)

  repeat result from 0 to localSize - 1
    TbugTx(byte[localPtr + result])
      
PRI Tbug(localPtr)

  'Tv.str(localPtr)
  Com.str(_DebugCom, localPtr)
  'Com.str(_BoardC, localPtr)

PRI TbugDec(localDec)

  'Tv.dec(localDec)
  Com.dec(_DebugCom, localDec)
  'Com.dec(_BoardC, localDec)

PRI TbugDecf(localDec, localSize)

  'Tv.decf(localDec, localSize)
  Com.decf(_DebugCom, localDec, localSize)
  'Com.decf(_BoardC, localDec, localSize)

PRI TbugTx(localCharacter)

  if (localCharacter > 31 and localCharacter < 127) or localCharacter == 13
    'Tv.out(localCharacter)
    Com.tx(_DebugCom, localCharacter)
    'Com.tx(_BoardC, localCharacter)
  else
    'Tv.out(60)
    'Tv.out(36)
    Com.tx(_DebugCom, 60)
    Com.tx(_DebugCom, 36)
    'Com.tx(_BoardC, 60)
    'Com.tx(_BoardC, 36)
    TbugHex(localCharacter, 2)
    'Tv.out(62)
    Com.tx(_DebugCom, 62)
    'Com.tx(_BoardC, 62) 
    
PRI TbugHex(localHex, localSize)
 
  'Tv.hex(localHex, localSize)
  Com.hex(_DebugCom, localHex, localSize)
  'Com.hex(_BoardC, localHex, localSize)

PRI TbugBin(localBin, localSize)

  'Tv.bin(localBin, localSize)
  Com.bin(_DebugCom, localBin, localSize)
  'Com.bin(_BoardC, localBin, localSize)
                          '0  1   2    3   4                5                6+
DAT

roombaData    byte 0[34] ' 34 bytes is the largest data set sent to the Roomba
song0         byte 0, 15, 48, 16, 50, 16, 52, 16, 53, 16, 55, 16 ' 12 bytes
              byte 57, 16, 59, 16, 60, 16, 59, 16, 57, 16, 55, 16 ' 12 bytes
              byte 53, 16, 52, 16, 50, 16, 48, 16 ' 8 bytes, total of 32 bytes

nordicTxBuffer        byte 1, 2, "u", "w", 0, Header#_Command, 0[Header#_MecanumPayloadSize - 5]

DAT
''------------------ Cofig settings for new nRF24L01+ modules ----------------------------------------
'' ----------------- Keep below together and in order ------------------------------------------------
configNew     byte %00111111 '%00111011  Register $00
              ' use %00111111($3F)(2 bytes CRC) or %00111011($3B)(1 byte CRC)
              ' when communicating with older nRF2401A modules
              ' make sure this matches nRF2401A setting
              ' %00001111($0F) future with more irq options
              ' 7 only zero allowed, 6 Mask irq by RX_DR (1 = no irq), 5 Mask TX_DS, 4 Mask MAX_RT,
              ' 3 Enable CRC, 2 CRC size (1 = 2 bytes), 1 1 = power up, 0 1 = PRX 0 = PTX
              ' RX_DR Receive Data Ready
              ' TX_DS Transmit Data Sent
              ' MAX_RT Maximum Retries
              byte $00 '$03 ' Register $01 Auto Acknowledge
              ' use $00 when communicating with older nRF2401A modules
              ' %00111111 future
              ' 7:6 only %00, enable pipe 5 through 0
              byte %00000011 ' Register $02
              ' 7:6 only zero allowed, 5:0 enable rx addresses pipe 5:0
              byte $03 ' Register $03 SETUP_AW setup Address Widths 
              ' 7:2 only %000000, 1:0 %01 = 3 %11 = 5
              byte $00 ' Register $04 SETUP_RETR Setup Auto Retransmission
              ' use $00 when communicating with older nRF2401A modules     
              ' %00101111 = 750us delay to retx, tx 15 tries
              ' %01001111 = 1250us delay to retx, tx 15 tries
              ' 7:4 ARD delay 1111 = 4000us, 3:0 retry count 0 - 15 (1111)
              byte $02 ' Register $05 RF_CH RF Channel
              ' 7 leave 0, 6:0 frequency channel
              ' F = (2400 + RF_CH)MHz (both nRF24L01+ and nRF2401A modules)
              byte $06 ' Register $06 RF_SETUP RF Setup
              ' don't use 2Mbps when communicating with older nRF2401A modules
              ' $06 = 1Mbps and full power
              ' 7:6 %00 only, 5 RF_DR_LOW 1 = 250kbps use 0 for higher speeds, 4 leave %0
              ' 3 1 = 2Mbps 0 = 1Mbps, 2:1 RF_POWER %11 = 0dBm (highest power), 0 don't care
              ' Register $07 STATUS Status Register used below.
              ' Register $08 OBSERVE_TX 7:4 lost packet count (read only),
              ' 3:0 retransmitted packets count (read only).  I plan to use this
              ' register's infomation in the future.
              ' Register $09 RPD 7:1 reserved (read only), 0 Received Power Detector (read only)
              ' Register $0A RX_ADDR_P0 39:0 Receive address pipe 0, 5 bytes maximum LSByte written first
              ' used below rxAddress0 and rxAddress1
              ' Register $0B RX_ADDR_P1 39:0 Receive address pipe 1
              ' Register $0C RX_ADDR_P2 7:0 Receive address pipe 2
              ' Register $0D RX_ADDR_P3 7:0 Receive address pipe 3
              ' Register $0E RX_ADDR_P4 7:0 Receive address pipe 4
              ' Register $0F RX_ADDR_P5 7:0 Receive address pipe 5
              ' Register $10 TX_ADDR 39:0 Transmit address
'configNew[7]
nordicStatus  byte %01000000 ' $40   %01110000   '$70
              ' only zero allowed, Data Ready RX, TX ACK received, MAX_RT failed,
              ' 3:1 Data pipe with payload %111 if empty (read only), 0 1= TX FIFO full (read only)
rxPayload     byte Header#_MecanumPayloadSize '25 '32   ' Register $11 RX_PW_P0
              ' This will need to be reduced to 25 (assuming 2 bytes CRC and 5 bytes address)
              ' to work with older nRF2401 modules.
              ' Newer nRF24L01+ modules can have payloads as large as 32 bytes.
              ' 7:6 only zero allowed, 5:0 Number of bytes in RX payload in data pipe 0
              ' (1 to 32)(0 = pipe not used)
              ' Register $12 RX_PW_P1 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 1
              ' (1 to 32)(0 = pipe not used)
              ' Register $13 RX_PW_P2 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 2
              ' Register $14 RX_PW_P3 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 3
              ' Register $15 RX_PW_P4 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 4
              ' Register $16 RX_PW_P5 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 5
              ' Register $17 FIFO_STATUS 7 only zero allowed, 6 TX_REUSE (read only), 
              ' 5 TX_FULL %1 = full (read only), 4 TX_EMPTY %1 = empty (read only),
              ' 3:2 only zero allowed, 1 RX_FULL %1 = full (read only),
              ' 0 RX_EMPTY %1 = empty (read only)
              ' Register $1C DYNPD Enable dynamic payload length, 7:6 only zero allowed,
              ' 5 DPL_P5 Enable dynamic payload length data pipe 5 (Requires EN_DPL and ENAA_5)
              ' 4 DPL_P4 Enable dynamic payload length data pipe 4 (Requires EN_DPL and ENAA_4)
              ' 3 DPL_P3 Enable dynamic payload length data pipe 3 (Requires EN_DPL and ENAA_3)
              ' 2 DPL_P2 Enable dynamic payload length data pipe 2 (Requires EN_DPL and ENAA_2)
              ' 1 DPL_P1 Enable dynamic payload length data pipe 1 (Requires EN_DPL and ENAA_1)
              ' 0 DPL_P0 Enable dynamic payload length data pipe 0 (Requires EN_DPL and ENAA_0)
              ' Register $1D FEATURE Feature Register 7:3 only zero allowed,
              ' 2 EN_DPL Enables Dynamic Payload Length, 1 EN_ACK_PAY Enables Payload with ACK,
              ' 0 EN_DYN_ACK Enables the W_TX_PAYLOAD_NOACK command
              
'' ----------------- Keep above together and in order ------------------------------------------------             
'' ----------------- Keep below together and in order ------------------------------------------------             

rxAddress0    byte $E7[5] ' Register $0A Receive address data pipe 0, LSByte first
'rxAddress0    byte $CD, $E7, $E7, $E7, $CD ' Register $0A Receive address data pipe 0, LSByte first

txAddress0    byte $E7[5] ' Register $10 Transmit address data pipe 0, LSByte first
'txAddress0    byte $CD, $E7, $E7, $E7, $CD ' Register $10 Transmit address data pipe 0, LSByte first
'txAddress0    byte $C2, $C2, $C2, $C2, $C2 ' Register $10 Transmit address data pipe 0, LSByte first
'' ----------------- Keep above together and in order ------------------------------------------------             

'' ----------------- Keep below together and in order ------------------------------------------------             

rxAddress1    byte $E7[5] ' Register $0A Receive address data pipe 0, LSByte first
'rxAddress1    byte $CD, $E7, $E7, $E7, $CD ' Register $0A Receive address data pipe 0, LSByte first

txAddress1    byte $E7[5] '  Register $10 Transmit address data pipe 0, LSByte first
'txAddress1    byte $CD, $E7, $E7, $E7, $CD '  Register $10 Transmit address data pipe 0, LSByte first
'txAddress1    byte $C2, $C2, $C2, $C2, $C2 '  Register $10 Transmit address data pipe 0, LSByte first
'' ----------------- Keep above together and in order ------------------------------------------------

{DAT
''------------------ Cofig settings for new nRF24L01+ modules ----------------------------------------
'' ----------------- Keep below together and in order ------------------------------------------------
config        byte $78 - %01000000 + %00000011' %01111000
              byte $00
              byte %00000011
              byte $03 ' %00000011 ' five digit address
              byte $00
              byte $02 ' %00000010
              byte $07 ' %00000111 ' 1Mbit, 0dBm power, zero bit don't care same as $06
              byte Header#_ListenForFobReg5
              byte Header#_ListenForFobReg6
nordicStatus  byte Header#_NordicStatus
rxPayload     byte Header#_ListenForFobRxPayload '_RxPayload '25 '32   ' Register $11 RX_PW_P0

rxAddress     byte Header#_InitialAddressCharacter[5] ' Register $10 Transmit address data pipe 0, LSByte first
txAddress     byte Header#_InitialAddressCharacter[5] ' Register $10 Transmit address data pipe 0, LSByte first
'' ----------------- Keep above together and in order ------------------------------------------------
}
DAT  